--erken_odenen_taksit cotains the number of installments that were payed ahead of maturity date.
-- Bu tablolar filtre konularak alinmis, gereek dünyada sql'lere tarih kisiti konmasi gerekebilir

--select b.tar ac_tar_time, b.kap_tar  
--from dwf_banka_urun_kesit_kredi a
--join dw_out.hesap b  
--on a.sube = b.sube 
--and a.hesno = b.hesno ;

--Loan Opening  - with TL /YP / DEK difference
INSERT INTO onboarding.event_list
SELECT cmusno 
		,case WHEN kisa_ad like '%Konut%' and ad like '%TL%'  then 12001
		when kisa_ad like '%Konut%' and ad like '%YP%'  then 12002
		when kisa_ad like '%Konut%' and ad like '%DEK%'  then 12003
		WHEN kisa_ad like '%Taşıt%' and ad like '%TL%' then 12004
		WHEN kisa_ad like '%Taşıt%' and ad like '%YP%' then 12005
		WHEN kisa_ad like '%Taşıt%' and ad like '%DEK%' then 12006
		WHEN kisa_ad like '%İhtiyaç%' and ad like '%TL%' then 12007
		WHEN kisa_ad like '%İhtiyaç%' and ad like '%YP%' then 12008
		WHEN kisa_ad like '%İhtiyaç%' and ad like '%DEK%' then 12009
		WHEN kisa_ad like '%Bireysel Finansman%' and ad like '%TL%' then 12010
		WHEN kisa_ad like '%Bireysel Finansman%' and ad like '%YP%' then 12011
		WHEN kisa_ad like '%Bireysel Finansman%' and ad like '%DEK%' then 12012
		WHEN kisa_ad like '%İşyeri%' and ad like '%TL%' then 12013
		WHEN kisa_ad like '%İşyeri%' and ad like '%YP%' then 12014
		WHEN kisa_ad like '%İşyeri%' and ad like '%DEK%' then 12015
		END AS event_id
		, ac_tar as EVENT_DATE
		,'LOAN'
		,case when kisa_ad like '%Konut%' and ad like '%TL%' then 'MtgeOpenTL'
		when kisa_ad like '%Konut%' and ad like '%YP%' then 'MtgeOpenYP'
		when kisa_ad like '%Konut%' and ad like '%DEK%' then 'MtgeOpenDEK'
		when kisa_ad like '%Taşıt%' and ad like '%TL%'then 'CarLnOpenTL'
		when kisa_ad like '%Taşıt%' and ad like '%YP%' then 'CarLnOpenYP'
		when kisa_ad like '%Taşıt%' and ad like '%DEK%' then 'CarLnOpenDEK'
		when kisa_ad like '%İhtiyaç%'	and ad like '%TL%'then 'PerLnOpenTL'
		when kisa_ad like '%İhtiyaç%'	and ad like '%YP%' then 'PerLnOpenYP'
		when kisa_ad like '%İhtiyaç%'	and ad like '%DEK%' then 'PerLnOpenDEK'
		when kisa_ad like '%Bireysel Finansman%' and ad like '%TL%' then 'PerFinLnOpenTL'
		when kisa_ad like '%Bireysel Finansman%' and ad like '%YP%' then 'PerFinLnOpenYP'
		when kisa_ad like '%Bireysel Finansman%' and ad like '%DEK%' then 'PerFinLnOpenDEK'
		when kisa_ad like '%İşyeri%' and ad like '%TL%' then 'WorkplaceLnOpenTL'
		when kisa_ad like '%İşyeri%' and ad like '%YP%' then 'WorkplaceLnOpenYP'
		when kisa_ad like '%İşyeri%' and ad like '%DEK%' then 'WorkplaceLnOpenDEK'
		else 'LnOpen'
		end as event1
		,'' as event2
		,'' as EVENT3
		,'' as chn_name	
FROM
(
SELECT
tarih,
m.cmusno,
k.sube,
k.krdno,
h.tar as ac_tar,
son_taksit_vadesi,
h.kap_tar,
l.kul_tut,
u.kisa_ad,
u.ad
FROM 
staging.pov_dwf_banka_urun_kesit_kredi as k
join dw_out.hesap h  
	on k.sube = h.sube 
	and k.hesno = h.hesno
JOIN
onboarding.control_path control_tab 
ON 1=1
INNER JOIN staging.pov_ybs_hesap_ortak_musteri m
ON tarih = CAST(control_tab.end_date as DATE) AND k.sube=m.sube AND k.hesno=m.hesno AND k.krdno=m.krdno
LEFT JOIN 
(select sube, hesno, max(kul_tut) as kul_tut
from staging.POV_SNAP_S_YKRD_TUR_LIM_KUL_ISL
group by 1,2
) l
ON k.sube=l.sube AND k.hesno=l.hesno
LEFT JOIN staging.pov_banka_urun u
ON k.bankaurunid=u.id
WHERE h.tar between control_tab.start_date and control_tab.end_date
) DRV;

--STATEMENT 1: Insert Statement completed. 667899  rows processed. 
--count(1)
--344028

--Loan Close/Early Close  - with TL /YP / DEK difference
INSERT INTO onboarding.event_list
SELECT cmusno 
	,case WHEN kisa_ad like '%Konut%' and ad like '%TL%' and early_close_flag='Y' then 12016
		WHEN kisa_ad like '%Konut%' and ad like '%TL%' and early_close_flag != 'Y' then 12017
		when kisa_ad like '%Konut%' and ad like '%YP%' and early_close_flag='Y' then 12018
		when kisa_ad like '%Konut%' and ad like '%YP%' and early_close_flag != 'Y' then 12019
		when kisa_ad like '%Konut%' and ad like '%DEK%' and early_close_flag = 'Y' then 12020
		when kisa_ad like '%Konut%' and ad like '%DEK%' and early_close_flag != 'Y'  then 12021
		WHEN kisa_ad like '%Taşıt%' and ad like '%TL%' and early_close_flag = 'Y' then 12022
		WHEN kisa_ad like '%Taşıt%' and ad like '%TL%' and early_close_flag != 'Y' then 12023
		WHEN kisa_ad like '%Taşıt%' and ad like '%YP%' and early_close_flag = 'Y' then 12024
		WHEN kisa_ad like '%Taşıt%' and ad like '%YP%' and early_close_flag != 'Y' then 12025
		WHEN kisa_ad like '%Taşıt%' and ad like '%DEK%' and early_close_flag = 'Y' then 12026
		WHEN kisa_ad like '%Taşıt%' and ad like '%DEK%' and early_close_flag != 'Y' then 12027
		WHEN kisa_ad like '%İhtiyaç%' and ad like '%TL%' and early_close_flag = 'Y' then 12028
		WHEN kisa_ad like '%İhtiyaç%' and ad like '%TL%' and early_close_flag != 'Y' then 12029
		WHEN kisa_ad like '%İhtiyaç%' and ad like '%YP%' and early_close_flag = 'Y'  then 12030
		WHEN kisa_ad like '%İhtiyaç%' and ad like '%YP%' and early_close_flag != 'Y'  then 12031
		WHEN kisa_ad like '%İhtiyaç%' and ad like '%DEK%' and early_close_flag = 'Y'  then 12032
		WHEN kisa_ad like '%İhtiyaç%' and ad like '%DEK%' and early_close_flag != 'Y'  then 12033
		WHEN kisa_ad like '%Bireysel Finansman%' and ad like '%TL%' and early_close_flag = 'Y' then 12034
		WHEN kisa_ad like '%Bireysel Finansman%' and ad like '%TL%' and early_close_flag != 'Y'  then 12035
		WHEN kisa_ad like '%Bireysel Finansman%' and ad like '%YP%' and early_close_flag = 'Y' then 12036
		WHEN kisa_ad like '%Bireysel Finansman%' and ad like '%YP%' and early_close_flag != 'Y' then 12037
		WHEN kisa_ad like '%Bireysel Finansman%' and ad like '%DEK%' and early_close_flag = 'Y' then 12038
		WHEN kisa_ad like '%Bireysel Finansman%' and ad like '%DEK%' and early_close_flag != 'Y' then 12039
		WHEN kisa_ad like '%İşyeri%' and ad like '%TL%' and early_close_flag = 'Y' then 12040
		WHEN kisa_ad like '%İşyeri%' and ad like '%TL%' and early_close_flag != 'Y' then 12041
		WHEN kisa_ad like '%İşyeri%' and ad like '%YP%' and early_close_flag = 'Y' then 12042
		WHEN kisa_ad like '%İşyeri%' and ad like '%YP%' and early_close_flag != 'Y' then 12043
		WHEN kisa_ad like '%İşyeri%' and ad like '%DEK%' and early_close_flag = 'Y' then 12044
		WHEN kisa_ad like '%İşyeri%' and ad like '%DEK%' and early_close_flag != 'Y' then 12045
		END AS event_id
		, kap_tar as EVENT_DATE
		,'LOAN'
		,case when kisa_ad like '%Konut%' and ad like '%TL%' then 'MtgeCloseTL'
		when kisa_ad like '%Konut%' and ad like '%YP%' then 'MtgeCloseYP'
		when kisa_ad like '%Konut%' and ad like '%DEK%' then 'MtgeCloseDEK'
		when kisa_ad like '%Taşıt%' and ad like '%TL%'then 'CarLnCloseTL'
		when kisa_ad like '%Taşıt%' and ad like '%YP%' then 'CarLnCloseYP'
		when kisa_ad like '%Taşıt%' and ad like '%DEK%' then 'CarLnCloseDEK'
		when kisa_ad like '%İhtiyaç%'	and ad like '%TL%'then 'PerLnCloseTL'
		when kisa_ad like '%İhtiyaç%'	and ad like '%YP%' then 'PerLnCloseYP'
		when kisa_ad like '%İhtiyaç%'	and ad like '%DEK%' then 'PerLnCloseDEK'
		when kisa_ad like '%Bireysel Finansman%' and ad like '%TL%' then 'PerFinLnCloseTL'
		when kisa_ad like '%Bireysel Finansman%' and ad like '%YP%' then 'PerFinLnCloseYP'
		when kisa_ad like '%Bireysel Finansman%' and ad like '%DEK%' then 'PerFinLnCloseDEK'
		when kisa_ad like '%İşyeri%' and ad like '%TL%' then 'WorkplaceLnCloseTL'
		when kisa_ad like '%İşyeri%' and ad like '%YP%' then 'WorkplaceLnCloseYP'
		when kisa_ad like '%İşyeri%' and ad like '%DEK%' then 'WorkplaceLnCloseDEK'
		else 'LnClose'
		end as event1
		,CASE WHEN early_close_flag='Y' THEN 'Early'
				ELSE 'OnTime' END as EVENT2
		,'' as event3
		,'' as chn_name		
FROM
(
SELECT
tarih,
m.cmusno,
k.sube,
k.krdno,
h.tar as ac_tar,
son_taksit_vadesi,
h.kap_tar,
l.kul_tut,
u.kisa_ad,
u.ad,
CASE	WHEN erken_odeme_tarihi IS NOT NULL AND erken_odeme_tarihi<son_taksit_vadesi THEN 'Y' 
		ELSE 'N' 
		END 
		as early_close_flag
FROM 
staging.pov_dwf_banka_urun_kesit_kredi as k
join dw_out.hesap h  
	on k.sube = h.sube 
	and k.hesno = h.hesno
JOIN
onboarding.control_path control_tab 
ON 1=1
INNER JOIN staging.pov_ybs_hesap_ortak_musteri m
ON tarih = CAST(control_tab.end_date as DATE) AND k.sube=m.sube AND k.hesno=m.hesno AND k.krdno=m.krdno
LEFT JOIN 
(select sube, hesno, max(kul_tut) as kul_tut
from staging.POV_SNAP_S_YKRD_TUR_LIM_KUL_ISL
group by 1,2
) l
ON k.sube=l.sube AND k.hesno=l.hesno
LEFT JOIN staging.pov_banka_urun u
ON k.bankaurunid=u.id
WHERE h.kap_tar between control_tab.start_date and control_tab.end_date
) DRV;

--STATEMENT 2: Insert Statement completed. 677161  rows processed.
--count(1)
--451822
--select * from staging.path_events where cust_id=  and domain_type='LOAN';

/*
select event_id, domain_type, EVENT1, EVENT2, EVENT3, count(cmusno)
from onboarding.event_list
where domain_type='LOAN'
group by event_id, domain_type, EVENT1, EVENT2, EVENT3;

select  domain_type, EVENT1, EVENT2, EVENT3, count(cust_id)
from staging.path_events
where domain_type='LOAN'
group by  domain_type, EVENT1, EVENT2, EVENT3;
*/
--
----Loan Opening - without TL /YP / DEK difference
--INSERT INTO onboarding.event_list
--SELECT cmusno 
--		,case WHEN kisa_ad like '%Konut%'   then 12046
--		WHEN kisa_ad like '%Taşıt%' then 12047
--		WHEN kisa_ad like '%İhtiyaç%'  then 12048
--		WHEN kisa_ad like '%Bireysel Finansman%' then 12049
--		WHEN kisa_ad like '%İşyeri%' then 12050
--		END AS event_id
--		, ac_tar as EVENT_DATE
--		,'LOAN'
--		,case when kisa_ad like '%Konut%' then 'MtgeOpen'
--		when kisa_ad like '%Taşıt%' then 'CarLnOpen'
--		when kisa_ad like '%İhtiyaç%'	then 'PerLnOpen'
--		when kisa_ad like '%Bireysel Finansman%' then 'PerFinLnOpen'
--		when kisa_ad like '%İşyeri%' then 'WorkplaceLnOpen'
--		else ''
--		end as event1
--		,'' event2
--		,'' as EVENT3
--		,'' as chn_name	
--FROM
--(
--SELECT
--tarih,
--m.cmusno,
--k.sube,
--k.krdno,
--k.ac_tar,
--son_taksit_vadesi,
--k.kap_tar,
--l.kul_tut,
--u.kisa_ad,
--u.ad
--FROM 
--staging.pov_dwf_banka_urun_kesit_kredi as k
--JOIN
--onboarding.control_path control_tab 
--ON 1=1
--INNER JOIN staging.pov_ybs_hesap_ortak_musteri m
--ON tarih = '05/31/2018'/*CAST(control_tab.end_date as DATE)*/ AND k.sube=m.sube AND k.hesno=m.hesno AND k.krdno=m.krdno
--LEFT JOIN 
--(select sube, hesno, max(kul_tut) as kul_tut
--from staging.POV_SNAP_S_YKRD_TUR_LIM_KUL_ISL
--group by 1,2
--) l
--ON k.sube=l.sube AND k.hesno=l.hesno
--LEFT JOIN staging.pov_banka_urun u
--ON k.bankaurunid=u.id
--WHERE k.ac_tar>=CAST(control_tab.start_date as DATE)
--) DRV;
----STATEMENT 3: Insert Statement completed. 341142 rows processed.
--
----Loan Close/Early Close - without TL /YP / DEK difference
--INSERT INTO onboarding.event_list
--SELECT cmusno 
--	,case WHEN kisa_ad like '%Konut%' and early_close_flag='Y' then 12051
--		WHEN kisa_ad like '%Konut%' and early_close_flag != 'Y' then 12052
--		WHEN kisa_ad like '%Taşıt%' and early_close_flag = 'Y' then 12053
--		WHEN kisa_ad like '%Taşıt%' and early_close_flag != 'Y' then 12054
--		WHEN kisa_ad like '%İhtiyaç%' and early_close_flag = 'Y' then 12055
--		WHEN kisa_ad like '%İhtiyaç%' and early_close_flag != 'Y' then 12056
--		WHEN kisa_ad like '%Bireysel Finansman%' and early_close_flag = 'Y' then 12057
--		WHEN kisa_ad like '%Bireysel Finansman%' and early_close_flag != 'Y'  then 12058
--		WHEN kisa_ad like '%İşyeri%' and early_close_flag = 'Y' then 12059
--		WHEN kisa_ad like '%İşyeri%' and early_close_flag != 'Y' then 12060
--		END AS event_id
--		, kap_tar as EVENT_DATE
--		,'LOAN'
--		,case when kisa_ad like '%Konut%' then 'MtgeClose'
--		when kisa_ad like '%Taşıt%' then 'CarLnClose'
--		when kisa_ad like '%İhtiyaç%'	then 'PerLnClose'
--		when kisa_ad like '%Bireysel Finansman%' then 'PerFinLnClose'
--		when kisa_ad like '%İşyeri%' then 'WorkplaceLnClose'
--		else 'LnClose'
--		end as event1
--		,CASE WHEN early_close_flag='Y' THEN 'Early'
--				ELSE 'OnTime' END as EVENT2
--		,'' event3
--		,'' as chn_name		
--FROM
--(
--SELECT
--tarih,
--m.cmusno,
--k.sube,
--k.krdno,
--k.ac_tar,
--son_taksit_vadesi,
--k.kap_tar,
--l.kul_tut,
--u.kisa_ad,
--u.ad,
--CASE	WHEN erken_odeme_tarihi IS NOT NULL AND erken_odeme_tarihi<son_taksit_vadesi THEN 'Y' 
--		ELSE 'N' 
--		END 
--		as early_close_flag
--FROM 
--staging.pov_dwf_banka_urun_kesit_kredi as k
--JOIN
--onboarding.control_path control_tab 
--ON 1=1
--INNER JOIN staging.pov_ybs_hesap_ortak_musteri m
--ON tarih = '05/31/2018'/*CAST(control_tab.end_date as DATE)*/ AND k.sube=m.sube AND k.hesno=m.hesno AND k.krdno=m.krdno
--LEFT JOIN 
--(select sube, hesno, max(kul_tut) as kul_tut
--from staging.POV_SNAP_S_YKRD_TUR_LIM_KUL_ISL
--group by 1,2
--) l
--ON k.sube=l.sube AND k.hesno=l.hesno
--LEFT JOIN staging.pov_banka_urun u
--ON k.bankaurunid=u.id
--WHERE k.kap_tar>=CAST(control_tab.start_date as DATE)
--) DRV;
----STATEMENT 4: Insert Statement completed. 317757 rows processed.
--
--/*
--select event_id, domain_type, EVENT1, EVENT2, EVENT3, count(cmusno)
--from onboarding.event_list
--where domain_type='LOAN' and event_id >= 12046
--group by event_id, domain_type, EVENT1, EVENT2, EVENT3;
--
--select  domain_type, EVENT1, EVENT2, EVENT3, count(cust_id)
--from staging.path_events
--where domain_type='LOAN'
--group by  domain_type, EVENT1, EVENT2, EVENT3;
--*/
--
--
--/*
----Loan Early Close
--SELECT MIN(ac_tar)
--FROM
--(
--SELECT 
--m.cmusno,
--k.sube,
--k.krdno,
--k.ac_tar,
--son_taksit_vadesi,
--erken_odeme_tarihi,
--k.kap_tar,
--erken_odenen_taksit,
----l.kul_tut,
--u.kisa_ad,
--u.ad
--FROM 
--pov_dwf_banka_urun_kesit_kredi k
--INNER JOIN
--pov_ybs_hesap_ortak_musteri m
--ON tarih = '31/07/2017' and k.sube=m.sube and k.hesno=m.hesno and k.krdno=m.krdno
----LEFT JOIN
----pov_SNAP$_S_YKRD_TUR_LIM_KUL_ISL l
----ON k.sube=l.sube and k.hesno=l.hesno
--LEFT JOIN
--pov_banka_urun u
--ON k.bankaurunid=u.id
--WHERE erken_odeme_tarihi IS NOT NULL
--AND erken_odeme_tarihi<son_taksit_vadesi
--AND k.kap_tar>='2017-01-01'
--) DRV
--*/