Drop table if exists onboarding.application_tmp1;
create table onboarding.application_tmp1
distribute by hash(SS_CR_APP_NO)
compress
as
select
        a.cst_id,
		c.tar as basvuru_tar,
        c.basvuru_sonuc_tar,
        c.basvuru_sonuc_tar_saat,
        c.basvuruno,
        a.SS_CR_APP_NO,
        c.brykrdteklifno            
FROM staging.pov_dim_cr_app_smy  a
inner join dw_out.basvuru c
	on  a.SS_CR_APP_NO  = c.basvuruno::varchar(20)
	and as_of_dt='05-31-2018'
    union 
     select
        a.cst_id,
		c.tar as basvuru_tar,
        c.sonuc_tar as basvuru_sonuc_tar,
        null as basvuru_sonuc_tar_saat,
        null as basvuruno,
        a.SS_CR_APP_NO,
        c.brykrdteklifno            
FROM staging.pov_dim_cr_app_smy  a
inner join dw_out.bry_krd_teklif c
	on  a.SS_CR_APP_NO  = c.brykrdteklifno::varchar(20)
	and as_of_dt='05-31-2018';
	--and (cl_app_tp_code not in ('7','E','I','K') or cl_app_tp_code is null) -- basvuru tablosu kullanilirken ticari krediler gelmesin diye bu eleme yapiliyordu
	
--talep_krdturkod alani bry_krd_teklif tablosundaki basvuru urun bilgsini iceriyor


--select count(*) 
--from onboarding.application_tmp1; 
--count(1)
--100726820

--select count(distinct SS_CR_APP_NO)
--from onboarding.application_tmp1;
--93167950

--Delete from onboarding.event_list where domain_type='APPLICATION';
	
--basvuru tarihi eventi
insert into onboarding.event_list
SELECT  b.cmusno
		,CASE   
				WHEN cl_idv_ofr_tp_code in ('4','5','6') AND cl_app_tp_code = 'TK' THEN  29001
		   		WHEN cl_idv_ofr_tp_code in ('4','5','6') AND cl_app_tp_code = 'KK' THEN  29002
		   		WHEN cl_idv_ofr_tp_code in ('4','5','6') AND cl_app_tp_code = 'KL' THEN  29003
				WHEN cl_app_tp_code in ('TK','EK','E') THEN 29004
				WHEN cl_app_tp_code='KK' THEN 29005
				WHEN cl_app_tp_code in ('KL','EL') THEN 29006			
				WHEN cl_app_tp_code='KE' THEN 29007				
				WHEN cl_app_tp_code='I' THEN 29008
				WHEN cl_app_tp_code='K' THEN 29009
				WHEN cl_app_tp_code in ('KMH','FYB','FYI') THEN 29010
				ELSE 29011
		END as event_id
		,case 
			when c.basvuru_tar is not null then c.basvuru_tar
			else (a.app_dt /* + interval '23:59:59'*/) end 
		 as EVENT_DATE
		,'APPLICATION' as DOMAIN_TYPE
		, CASE 
				WHEN (cl_app_tp_code in ('TK','EK')
					and app_pd != 'KMH')
					or (cl_app_tp_code is null 
					and cl_cr_app_tp_code in ('3','2') 
					and app_pd='Tüketici Kredisi') THEN 'PerLoan_App'
				WHEN cl_app_tp_code='KK'
					or (cl_app_tp_code is null
					and cl_cr_app_tp_code in ('1','5') )THEN 'CC-Prm_App'
				WHEN cl_app_tp_code in ('KL','EL') THEN 'CCLimitInc_App'				
				WHEN cl_app_tp_code='KE'
					or (cl_app_tp_code is null
					and cl_cr_app_tp_code = '6' ) THEN 'CC-Sup_App'				
				WHEN cl_app_tp_code='I' THEN 'ComLoan_App'
				WHEN cl_app_tp_code in ('K','E')
					 or cl_app_tp_code = '7'  THEN 'CorpLoan_App'
				WHEN cl_app_tp_code in ('KMH','FYB','FYI')
					or (cl_app_tp_code is null 
					and cl_cr_app_tp_code = '2' 
					and app_pd='KMH')
					or (cl_app_tp_code = 'TK'
					and app_pd = 'KMH') THEN 'OVD_App'
				ELSE 'UnknownApp'
		END as EVENT1
		,'' as EVENT2
		,'' as EVENT3
		,cnl_nm as CHANNEL
FROM staging.pov_dim_cr_app_smy a
left JOIN onboarding.application_tmp1 c
	on  a.SS_CR_APP_NO = c.SS_CR_APP_NO
JOIN onboarding.control_path control_tab ON 1=1
JOIN "dw_out"."cmusteri_tum_key" b
	on a.cst_id=b.sk 
where ((cl_idv_ofr_tp_code not in ('4','5','6') or cl_idv_ofr_tp_code is null))
	and app_pd != 'UNKNOWN'
	and a.app_dt BETWEEN control_tab.start_date AND control_tab.end_date
	and as_of_dt=control_tab.snapshot_date;

--Insert Statement completed. 33 302 853 (29 611 884) rows processed.
	
--basvuru bitis tarihi eventi:

--select cl_app_tp_code, count(*)
--FROM staging.pov_dim_cr_app_smy a
--left JOIN onboarding.application_tmp1 c
--	on  a.SS_CR_APP_NO = c.SS_CR_APP_NO
--JOIN onboarding.control_path control_tab ON 1=1
--JOIN "dw_out"."cmusteri_tum_key" b
--	on a.cst_id=b.sk 
--where ((cl_idv_ofr_tp_code not in ('4','5','6') or cl_idv_ofr_tp_code is null))
--	and a.app_dt BETWEEN control_tab.start_date AND control_tab.end_date
--	and as_of_dt='05-31-2018'
--	and cl_app_tp_code is null
--	group by 1;	
	
--select event1, event2, count(*)
--from onboarding.event_list
--where domain_type='APPLICATION'
--group by 1,2;

insert into onboarding.event_list
SELECT  b.cmusno
		,CASE   
				WHEN cl_idv_ofr_tp_code in ('4','5','6') AND cl_app_tp_code = 'TK' THEN  29012
		   		WHEN cl_idv_ofr_tp_code in ('4','5','6') AND cl_app_tp_code = 'KK' THEN  29013
		   		WHEN cl_idv_ofr_tp_code in ('4','5','6') AND cl_app_tp_code = 'KL' THEN  29014
				WHEN cl_app_tp_code in ('TK','EK','E') THEN 29015
				WHEN cl_app_tp_code='KK' THEN 29016
				WHEN cl_app_tp_code in ('KL','EL') THEN 29017			
				WHEN cl_app_tp_code='KE' THEN 29018				
				WHEN cl_app_tp_code='I' THEN 29019
				WHEN cl_app_tp_code='K' THEN 29020
				WHEN cl_app_tp_code in ('KMH','FYB','FYI') THEN 29021
				ELSE 29022
		END as event_id
		,case 
			when c.basvuru_sonuc_tar_saat is not null then c.basvuru_sonuc_tar_saat
			when c.basvuru_sonuc_tar_saat is null and c.basvuru_sonuc_tar is not null then c.basvuru_sonuc_tar
			else (a.app_fnlz_dt + interval '23:59:59') end 
		 as EVENT_DATE
		,'APPLICATION' as DOMAIN_TYPE
		, CASE  WHEN cl_idv_ofr_tp_code in ('4','5','6') AND cl_app_tp_code in ('TK','OOK') THEN  'PreAprvdLoan'
		   		WHEN cl_idv_ofr_tp_code in ('4','5','6') AND cl_app_tp_code = 'KK' THEN  'PreAprovdCC'
		   		WHEN cl_idv_ofr_tp_code in ('4','5','6') AND cl_app_tp_code = 'KL' THEN  'PreAprvdCCLmt'
				WHEN (cl_app_tp_code in ('TK','EK')
					and app_pd != 'KMH')
					or (cl_app_tp_code is null 
					and cl_cr_app_tp_code in ('3','2') 
					and app_pd='Tüketici Kredisi') THEN 'PerLoan_App'
				WHEN cl_app_tp_code='KK'
					or (cl_app_tp_code is null
					and cl_cr_app_tp_code in ('1','5') )THEN 'CC-Prm_App'
				WHEN cl_app_tp_code in ('KL','EL') THEN 'CCLimitInc_App'				
				WHEN cl_app_tp_code='KE'
					or (cl_app_tp_code is null
					and cl_cr_app_tp_code = '6' ) THEN 'CC-Sup_App'				
				WHEN cl_app_tp_code='I' THEN 'ComLoan_App'
				WHEN cl_app_tp_code in ('K','E')
					 or cl_app_tp_code = '7'  THEN 'CorpLoan_App'
				WHEN cl_app_tp_code in ('KMH','FYB','FYI')
					or (cl_app_tp_code is null 
					and cl_cr_app_tp_code = '2' 
					and app_pd='KMH')
					or (cl_app_tp_code = 'TK'
					and app_pd = 'KMH') THEN 'OVD_App'
				ELSE 'UnknownApp'
		END as EVENT1
		,case when cl_cr_app_st_code='IPT' then 'Cncl'
		      when cl_app_rslt_cgy_code='3' then 'Apprvd'
			  when cl_app_rslt_cgy_code='2' then 'Rejctd' end	as EVENT2
		,'' as EVENT3
		,cnl_nm as CHANNEL
FROM staging.pov_dim_cr_app_smy a
left JOIN onboarding.application_tmp1 c
	on  a.SS_CR_APP_NO = c.SS_CR_APP_NO
JOIN onboarding.control_path control_tab ON 1=1
JOIN "dw_out"."cmusteri_tum_key" b
	on a.cst_id=b.sk 
where  a.app_fnlz_dt BETWEEN control_tab.start_date AND control_tab.end_date
	and app_pd != 'UNKNOWN'
	and as_of_dt=control_tab.snapshot_date
	and (cl_app_rslt_cgy_code in ('2','3') or cl_cr_app_st_code='IPT');
	
--Insert Statement completed. 27 587 998 (23 867 763) rows processed.
	
select event1, event2, count(*)
from onboarding.event_list
where domain_type='APPLICATION'
group by 1,2;
	
--drop table onboarding.application_tmp1;

--select cl_cr_app_st_code, cl_app_rslt_cgy_code, count(*)
--from staging.pov_dim_cr_app_smy
--group by 1,2;