  
/*

DROP TABLE IF EXISTS staging.pov_lp_atm_group;

CREATE DIMENSION TABLE staging.pov_lp_atm_group
(
   card_type character varying(5),
   txn_text character varying(200),
   Urun character varying(50),
   evt1 character varying(100),
   evt2 character varying(100),
   Gruplama character varying(50),
   YN character varying(5),
   event_id_cc	numeric(10,0),
   event_id_dc numeric(10,0)

)
DISTRIBUTE BY REPLICATION
STORAGE ROW;
*/
--DELETE FROM onboarding.event_list WHERE DOMAIN_TYPE='ATM_TRX';

--ATM Credit Card TXN Events

INSERT INTO onboarding.event_list
select CMUSNO,
		event_id,
		EVENT_DATE,
		'ATM_TRX',
		EVENT1,
		EVENT2,
		EVENT3,
		chn_name
from
(
SELECT 	CMUSNO
		, event_id_cc as event_id
		,ISLEM_TAR_SAAT as EVENT_DATE
		,'ATM_TRX'
		, 'ATMCC_' || Gruplama as EVENT1
		,'' AS EVENT2
		,'' as EVENT3
		,'ATM' as chn_name
FROM
onboarding.EVENT_CC_ATM_TRX a
JOIN
onboarding.control_path control_tab 
ON 1=1
LEFT JOIN
staging.pov_lp_atm_group
ON txn_name=TXN_TEXT AND CARD_TYPE='CC' and YN='Y'
where  ISLEM_TAR_SAAT between control_tab.start_date AND control_tab.end_date )drv
where drv.event1 is not null;

--STATEMENT 1: Insert Statement completed. 34460335   rows processed.
 
--ATM Debit Card TXN Events
INSERT INTO onboarding.event_list
select CMUSNO,
		event_id,
		EVENT_DATE,
		'ATM_TRX',
		EVENT1,
		EVENT2,
		EVENT3,
		chn_name
from
(
SELECT 	CMUSNO
		, event_id_dc as event_id
		, ISLEM_TAR_SAAT as EVENT_DATE
		,'ATM_TRX'
		, 'ATMDC_' || Gruplama as EVENT1
		, '' as EVENT2
		,'' as EVENT3
		,'ATM' as chn_name		
FROM
onboarding.EVENT_DEBIT_ATM_TRX
JOIN
onboarding.control_path control_tab 
ON 1=1
LEFT JOIN
staging.pov_lp_atm_group
ON txn_name=TXN_TEXT AND CARD_TYPE='DC' and YN='Y'
where ISLEM_TAR_SAAT between control_tab.start_date AND control_tab.end_date ) drv
where drv.event1 is not null;
--STATEMENT 2: Insert Statement completed. 80178293   rows processed.
 

--select * from zeren.customer_info limit 100;



/*
select event_id, domain_type, EVENT1, EVENT2, EVENT3, count(cmusno)
from onboarding.event_list
where domain_type='ATM_TRX'
group by event_id, domain_type, EVENT1, EVENT2, EVENT3;

select  domain_type, EVENT1, EVENT2, EVENT3, count(cust_id)
from staging.path_events
where domain_type='LOAN'
group by  domain_type, EVENT1, EVENT2, EVENT3;
*/