--table create script for POV_EVENT_CC_ATM_TRX
--table creation 
Drop table onboarding.EVENT_CC_ATM_TRX;
CREATE FACT TABLE onboarding.EVENT_CC_ATM_TRX
(
CMUSNO DECIMAL(8),       --BANKING_CUSTOMER_NO will be used as "CMUSNO" and it will be taken from "vy_cst_customer" table
ISLEM_TARIH DECIMAL(8),  --REQ_DATE will be used as "ISLEM_TARIH" and it will be taken from "atm_txn" table
ISLEM_SAAT DECIMAL(6),   --REQ_TIME will be used as "ISLEM_SAAT" and it will be taken from "atm_txn" table
ISLEM_TAR_SAAT TIMESTAMP(0),
TXN_NAME VARCHAR(512)    --This column will be taken from "prm_txn_def" table
)
DISTRIBUTE BY HASH (CMUSNO)
compress;

--table insert
insert into onboarding.EVENT_CC_ATM_TRX
select 
m.BANKING_CUSTOMER_NO,
a.REQ_DATE,
a.REQ_TIME,
CAST(TO_TIMESTAMP(CAST(REQ_DATE as VARCHAR(8))||(
			CASE WHEN LENGTH(CAST(REQ_TIME as VARCHAR(6))) = 1 THEN ('00000'|| CAST(REQ_TIME as VARCHAR(6)))
				 WHEN LENGTH(CAST(REQ_TIME as VARCHAR(6))) = 2 THEN ('0000'|| CAST(REQ_TIME as VARCHAR(6)))
				 WHEN LENGTH(CAST(REQ_TIME as VARCHAR(6))) = 3 THEN ('000'|| CAST(REQ_TIME as VARCHAR(6)))
				 WHEN LENGTH(CAST(REQ_TIME as VARCHAR(6))) = 4 THEN ('00'|| CAST(REQ_TIME as VARCHAR(6)))
				 WHEN LENGTH(CAST(REQ_TIME as VARCHAR(6))) = 5 THEN ('0'|| CAST(REQ_TIME as VARCHAR(6)))
				 WHEN LENGTH(CAST(REQ_TIME as VARCHAR(6))) = 6 THEN CAST(REQ_TIME as VARCHAR(6))
				 ELSE '000000' END),'YYYYMMDDHH24MISS') 
		AS TIMESTAMP(0)) as ISLEM_TAR_SAAT,
d.TXN_NAME
from staging.pov_atm_txn a, staging.pov_vy_crd_card c, staging.pov_vy_cst_customer m,staging.pov_prm_txn_def d
JOIN
onboarding.control_path control_tab 
ON 1=1
where a.f2=((c.card_no::numeric(16,0)-9876)::varchar(16))
and c.customer_no=m.customer_no
and a.ots=d.ots
and a.otc=d.otc
and a.ote=d.ote
and d.is_atm_txn=1
AND (REQ_DATE::varchar)::date between control_tab.start_date::date AND control_tab.end_date::date;

-- Insert Statement completed. 35 159 513 rows processed. 
								 

