--Customer status change (address Branch etc)

DROP TABLE IF EXISTS onboarding.customer_status_change;
CREATE TABLE onboarding.customer_status_change
(
cmusno  NUMERIC(8,0),
upd_date TIMESTAMP,
old_value VARCHAR(50),
new_value VARCHAR(50),
upd_code VARCHAR(5),
upd_info VARCHAR(100),
upd_chnl VARCHAR(100),
null_adress_flag VARCHAR(1)
) DISTRIBUTE BY HASH(cmusno);

INSERT INTO onboarding.customer_status_change
select 
g.cmusno,
g.gnc_tar,
g.eski_deg,
g.yeni_deg,
g.ref_dw_gnc_bilgi guncellenen_bilgi_kod_deg,
r1.ack guncellenen_bilgi_ack,
r2.ack guncelleme_kanal,
CASE	WHEN (g.eski_deg IS NULL OR g.yeni_deg IS NULL) AND ref_dw_gnc_bilgi IN ('201','358') 
		THEN 'Y' 
		ELSE 'N' 
		END as null_adress_flag
from staging.pov_dwd_ky_musbil_gnc_v2 g, staging.pov_dwr_referans r1, staging.pov_dwr_referans r2 
where  g.ref_dw_gnc_bilgi=r1.kod
and r1.tblad='DW_GNC_BILGI' 
and g.ref_dw_gnc_kanal=r2.kod
and r2.tblad='DW_GNC_KANAL'
and ref_dw_gnc_bilgi in ('201','302','303','304','358');


-- Insert Statement completed. 28293280 rows processed.