--Customer SMS/Email and Push messages from UNICA (we got this logic from Aleattin).

--table create script for POV_EVENT_MARK_OFFER_EMAILSMS
--table creation 
DROP TABLE IF EXISTS onboarding.EVENT_MARK_OFFER_EMAILSMS;
CREATE FACT TABLE onboarding.EVENT_MARK_OFFER_EMAILSMS
(
CMUSNO DECIMAL(20), --CMUSNO column will be taken from fes_kuyruk table
CHANNEL VARCHAR(5), --decode(tur,'E','E-Mail','S','SMS') will be taken as channel and TUR column will be taken from fes_tanim table
GONDERIM_TAR DATE, --EXE_TAR_SAAT column will be taken as GONDERIM_TAR and it will be taken from fes_kuyruk table
PRODUCT_NAME VARCHAR(100), --PRODUCT_NAME column will be taken as PRODUCT and it will be taken from offer table
PRODUCT_CATEGORY VARCHAR(100), --PRODUCT_CATEGORY column will be taken from offer table
FES_TANIM_NO DECIMAL(20),
AD VARCHAR(60),
MESSAGE_TYPE VARCHAR(40)
)
DISTRIBUTE BY HASH (CMUSNO)
compress;

INSERT INTO onboarding.EVENT_MARK_OFFER_EMAILSMS
select 
cmusno,
case 
	when t.festanimno = 10030 then 'Push' 
	else (case	when tur='E' then 'E-Mail'
				when tur='S' then 'SMS' end) 
end channel,
tarih gonderim_tar, 
o.product_name product, 
o.product_category,
t.festanimno,
t.ad,
case when res_grp_code='FesMessageKampanya' 
    and (upper (k.subject) like '%KAMPANYA%' or upper (k.subject) like '%TANITIM%'  or upper (k.prm) like '%TANITIM%'  or upper (k.prm) like '%KAMPANYA%' ) then 'Unica Kampanya'
    when res_grp_code='FesMessageKampanya' then 'Unica Bilgilendirme'
    when res_grp_code='FesMessageGenel' and (t.festanimno = 1198 or t.pazarlama_mes= 'E') then 'Genel Kampanya'
    else 'Genel Bilgilendirme' end Gonderim_detay_tur
from 
dw_out.fes_kuyruk_son k
INNER JOIN
staging.pov_fes_tanim t
ON k.festanimno=t.festanimno
LEFT JOIN
staging.pov_offer o 
ON k.offercode=o.offer_code
WHERE
k.drm='T' and k.cmusno is not null;

--

/*
select 
cmusno,
case when t.festanimno = 10030 then 'Push' else decode(tur,'E','E-Mail','S','SMS') end channel,
exe_tar_saat gonderim_tar, 
o.product_name product, 
o.product_category,
t.festanimno,
t.ad,
case when res_grp_code='FesMessageKampanya' 
    and (upper (k.subject) like '%KAMPANYA%' or upper (k.subject) like '%TANITIM%'  or upper (k.prm) like '%TANITIM%'  or upper (k.prm) like '%KAMPANYA%' ) then 'Unica Kampanya'
    when res_grp_code='FesMessageKampanya' then 'Unica Bilgilendirme'
    when res_grp_code='FesMessageGenel' and (t.festanimno = 1198 or t.pazarlama_mes= 'E') then 'Genel Kampanya'
    else 'Genel Bilgilendirme' end Gonderim_detay_tur
from ods_near.fes_kuyruk k, ods_near.fes_tanim t,ods_ext.offer o 
where k.festanimno=t.festanimno 
and k.feskuyrukno  > 20170101000000000000
and k.offercode=o.offer_code(+)
and drm='T'
and k.cmusno is not null;
*
/
------------------------------END OF THE ETL LOAD STATEMENT-------------------------------------------------
